service system/coldplug {
	depend = system/initial
	use = system/static-modules
	start {
		makeList() {
			ORDERING="/etc/hotplug/pci.rc /etc/hotplug/usb.rc /etc/hotplug/ide.rc /etc/hotplug/scsi.rc"
			LIST=""
			for x in /etc/hotplug/*.rc
			do
				FOUND=0
				for y in $ORDERING; do
					if [ "$x" = "$y" ]; then
						FOUND=1
					fi
				done
				if [ "$FOUND" -eq 0 ]; then
					LIST="$LIST $x"
				fi
			done
			LIST="$ORDERING $LIST"
		}
		makeList

		for x in $LIST; do
			if [ -x "$x" ]; then
				$x start &
			fi
		done
		
		wait

		#needed to make /dev/input/mice for X
		if [ -e /sys/class/input/mice/dev ]; then
		    mkdir -p /dev/input
		    mknod /dev/input/mice c 13 63 &>/dev/null
		fi
	
		exit 0
	}
   stop {
      for x in /etc/hotplug/*.rc; do
          $x stop || echo "Failed to stop $x"
      done
      exit 0
   } 
}
