service system/consolefont {
	depends = system/initial system/keymaps
start {
#/bin/bash
	if [ -f /etc/conf.d/consolefont ]
	then
	    source /etc/conf.d/consolefont
	fi

	if [ -f /etc/rc.conf ]
	then
	    source /etc/rc.conf
	fi

	# debian - ubuntu sources
	if [ -f /etc/console-tools/config ]
	then
	    source /etc/console-tools/config
	fi


	if [[ -n ${SCREEN_FONT} ]] ; then
	    CONSOLEFONT=${SCREEN_FONT}
	fi
	
	if [[ -z ${CONSOLEFONT} ]] ; then
		echo "Using the default console font"
		exit 0
	fi

	retval=1
	
	if [[ -x /bin/setfont ]] ; then
	    SETFONT="/bin/setfont"
	elif [[ -x /usr/bin/consolechars ]] ; then
	    SETFONT="/usr/bin/consolechars"
	    CONSOLEFONT="-f ${CONSOLEFONT}"
	else
	    echo "Coud not find set font utils ..."
	    exit 1
	fi
	# Get additional parameters
	if [[ -n ${CONSOLETRANSLATION} ]] ; then
		param="-m ${CONSOLETRANSLATION}"
	fi

	# Set the console font
	
	# We patched setfont to have --tty support ...
	if [[ -n $(${SETFONT} --help 2>&1 | grep -e '--tty') || \
		-n $(${SETFONT} --help 2>&1 | grep -e '-C') ]]
	    then
		if [[ -n $(${SETFONT} --help 2>&1 | grep -e '--tty') ]] ; then
		    sf_param="--tty="
		else
		    sf_param="-C "
		fi
		
		[[ -d /dev/vc ]] && ttydev=/dev/vc/ || ttydev=/dev/tty

		for x in $(seq 1 11) ; do
		    ${SETFONT} ${CONSOLEFONT} ${param} \
			${sf_param}/${ttydev}${x} >/dev/null
		    retval=$?
		done
	    else
		${SETFONT} ${CONSOLEFONT} ${param} >/dev/null
		retval=$?
	    fi
	
	exit $retval
}
}

