
service system/usb {
	depends = system/initial system/mountfs

start {
#!/bin/bash

# Make sure we insert usbcore if its a module
if [[ -f /proc/modules ]] ; then
    # >/dev/null to hide errors from non-USB users
    modprobe usbcore &> /dev/null
fi
	
# Check what USB fs the kernel support.  Currently
# 2.5+ kernels, and later 2.4 kernels have 'usbfs',
# while older kernels have 'usbdevfs'.
usbfs=$(grep -Fow usbfs /proc/filesystems || grep -Fow usbdevfs /proc/filesystems)

if [[ -n ${usbfs} ]] && [[ -e /proc/bus/usb && ! -e /proc/bus/usb/devices ]]
then
    echo "Mounting USB device filesystem (${usbfs}) ..."
    mount -t ${usbfs} none /proc/bus/usb &>/dev/null &
fi

exit 0
}
}
