
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef BUSYBOX
#include "../../busybox-1.00/include/busybox.h"
#include "../../busybox-1.00/include/libbb.h"
#endif
#include "../../src/initng.h"

#include <time.h>                           /* time() */
#include <fcntl.h>                          /* fcntl() */
#include <unistd.h>                         /* execv() pipe() usleep() pause() chown() */
#include <sys/wait.h>                       /* waitpid() sa */
#include <sys/ioctl.h>                      /* ioctl() */
#include <stdlib.h>                         /* malloc() free() exit() */
#include <stdio.h>
#include <string.h>                         /* memset() strlen() */
#include <errno.h>

#include "../../src/initng_execute.h"       /* new_environ() */
#include "../../src/initng_global.h"
#include "../../src/initng_toolbox.h"

#include "bash_executor.h"

void bash_this(char *bash_code, active_h * s, char *args)
{
    D_("bash_this(%s);\n", s->name);
    /* Todo : move bash_this into initng_bash_launcher and parse args properly\n" */
    char **argtmp;
    argtmp = (char **) initng_calloc(8, sizeof(char *));
    argtmp[0] =
        (char *) initng_calloc(1, sizeof(char) * (15 + strlen(s->name)));
    strcpy(argtmp[0], "bash_helper[");
    strcat(argtmp[0], s->name);
    strcat(argtmp[0], "]");
    argtmp[1] = "--noprofile";
    argtmp[2] = "--norc";
    argtmp[3] = "-c";
    argtmp[4] = bash_code;
    argtmp[5] = s->name;
    argtmp[6] = args;
    argtmp[7] = NULL;
    execve("/bin/bash", argtmp, new_environ(s));
    free(argtmp[0]);
    free(argtmp);
    F_("bash_this(): child died!\n EEEEEEEEEEEEEEEEEEEEEEERRRRRRRRRRRROOOOOOOOOORR!\n");
    /* exit 1, why???, to emit signal? */
    initng_free();
    _exit(1);
}                                           /* end fork_and_exec() */
