
/* Initng, a 6next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"

#define _GNU_SOURCE
#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include "../../src/initng_toolbox.h"
#include "../../src/initng_global.h"
#include "../../src/service_db.h"


#include "print_service.h"
static const char *dgn(e_sdt opt);


/* P R I N T   S E R V I C E */

static const char *dgn(e_sdt opt)
{
    int i;

    for (i = 0; g.option_table[i].opt_name; i++)
    {
        if (g.option_table[i].opt_id == opt)
            return (g.option_table[i].opt_name);
    }
    return (NULL);
}

static void service_db_pr(char *p, e_sdt type, char *value)
{
    char *dup = NULL;

    while (p[0])
        p++;

    if (value)
    {

        if (strlen(value) > MAX_PRINT_LENGTH)
        {
            int i = 0;

            dup = i_strndup(value, MAX_PRINT_LENGTH);

            /* replace enters with '$' */
            for (i = 0; i <= MAX_PRINT_LENGTH; i++)
                if (dup[i] == '\n')
                    dup[i] = ';';
            sprintf(p, " @@ %s:\t\"%s...\"\n", dgn(type), dup);
            free(dup);
        }
        else
        {
            sprintf(p, " @@ %s:\t\"%s\"\n", dgn(type), value);
        }
    }
}

static void pr_int(char *to, e_sdt type, int value)
{
    while (to[0])
        to++;
    sprintf(to, " @@ %s:\t\"%i\"\n", dgn(type), value);
}

/* some stdout */
char *service_db_print(service_h * s)
{
    int i;
    char *p = NULL;

    assert(s);
    assert(s->name);

    p = initng_calloc(5000, sizeof(char));
    if (s->type == TYPE_SERVICE)
    {
        strcpy(p, "\n#   service \"");
        strcat(p, s->name);
        strcat(p, "\"\n");
    }
    else if (s->type == TYPE_CLASS)
    {
        strcpy(p, "\n#   class \"");
        strcat(p, s->name);
        strcat(p, "\"\n");
    }
    strcat(p, "    ------------------------ \n");
    for (i = 0; i < M_D_F; i++)
    {
        if (s->data[i].type != EMPTY)
        {
            if (s->data[i].dt == STRING || s->data[i].dt == STRINGS)
                service_db_pr(p, s->data[i].type, s->data[i].t.s);
            if (s->data[i].dt == INT)
                pr_int(p, s->data[i].dt, s->data[i].t.i);
        }

    }
    return (p);
}

/* Walk through every service and print it all */
char *service_db_print_all(void)
{
    char *t = NULL;
    char *p = NULL;
    p = initng_calloc(10000, sizeof(char));
    strcpy(p, "Full service print:\n");
    service_h *next = NULL;

    D_("print_all():\n");
    while ((next = service_db_get_next(next)))
    {
        t = service_db_print(next);
        strcat(p, t);
        free(t);
    }
    /*printf("Full is:\"%s\"\n",p); */
    return (p);
}
