
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"
#define _GNU_SOURCE
#include <stdio.h>
#include <alloca.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <dirent.h>
#include "../../src/service_db.h"
#include "../../src/string_tools.h"
#include "../../src/initng_global.h"
#include "../../src/open_read_close.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_plugin_hook.h"

#include "initng_rc_parser.h"
#include "makerunlevel.h"
#include "inittab.h"

/* a simple parser for a runlevel file */
service_h *initng_rc_parser(char *runlevel_name)
{
    /* better to put sysvinit in default.runlevel and scan for sysvinit here? */

    if (strlen(runlevel_name) == 3)
    {
        if (strncmp(runlevel_name, "rc", 2) == 0)
        {
            if (!inittab_parsed)
                parseinittab();
            return make_new_runlevel(runlevel_name);
        }
    }
    return (NULL);
}

int module_init(void)
{
    D_("initng_rc_parser: moule_init();\n");
    inittab_parsed = FALSE;
    return (initng_add_hook(PARSERS, &initng_rc_parser));
}

void module_unload(void)
{
    D_("initng_rc_parser: moule_unload();\n");
    initng_del_hook(PARSERS, &initng_rc_parser);
}
