/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* This very simply parses /etc/inittab and adds apropriate services */

#include "../../src/initng.h"
#define _GNU_SOURCE
#include <stdio.h>
#include <alloca.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <dirent.h>
#include "../../src/service_db.h"
#include "../../src/string_tools.h"
#include "../../src/initng_global.h"
#include "../../src/open_read_close.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_plugin_hook.h"

#include "inittab.h"

/* Taken from init.c from sysvinit */
/*  * Version:  @(#)init.c  2.84  27-Nov-2001  miquels@cistron.nl */
/*
 *      My version of strtok(3).
 */
char *get_part(char *str, int tok)
{
    static char *s;
    char *p, *q;

    if (str != NULL)
        s = str;
    if (s == NULL || *s == 0)
        return (NULL);
    q = p = s;
    while (*p != tok && *p)
        p++;
    if (*p == tok)
        *p++ = 0;
    s = p;

    return q;
}

void inittab_line(char *line)
{
    char *id, *rlevel, *action, *process;       /* Fields of a line */
    char *p;
    char servicename[256];

    service_h *new_service = NULL;

    p = line;

    /* This block is taken from init.c from sysvinit */
    /*  * Version:      @(#)init.c  2.84  27-Nov-2001  miquels@cistron.nl */
    /*
     *  Skip comments and empty lines
     */
    {
        for (p = line; *p == ' ' || *p == '\t'; p++)
            ;
        if (*p == '#' || *p == '\n')
            return;

        id = get_part(p, ':');
        rlevel = get_part(NULL, ':');
        action = get_part(NULL, ':');
        process = get_part(NULL, '\n');
    }




    /*    printf("%s id for %s\n",id,line); */

    /* this is um... nasty ;) */
    if (strstr(process, "getty") != NULL)
    {
        printf("Data : %s,%s,%s,%s\n", id, rlevel, action, process);
        sprintf(servicename, "tty%s", id);
        service_db_new(&new_service, i_strdup(servicename), TYPE_SERVICE);
        /*        service_db_set_string(daemon, new_service, "todo /sbin/XXetty from process");
           service_db_set_string(daemon_args, new_service, "todo also from process");
           if (strcmp(action,"respawn") == 0) {
           service_db_set(RESPAWN,new_service);
           } */
        /* todo, add this as a up.i dependency. */
        /* can we just set before = up? */
        service_db_add(new_service);

    }
    /*service_db_new(&new_service, i_strdup(servicename), TYPE_SERVICE); */
}

void parseinittab()
{
    FILE *f;
    char buf[256];

    f = fopen("/etc/inittab", "r");
    while (fgets(buf, 4000, f))
    {
        inittab_line(buf);
    }

    fclose(f);
}
