
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_GLOBAL_H
#define INITNG_GLOBAL_H
#include "initng.h"
#include "service_db.h"
#include "active_db.h"
#include "initng_history.h"
#include "initng_module.h"
#include "initng_plugin.h"
#include "struct_data.h"

#include "static_data_id.h"

/* what to do when last process stops */
typedef enum
{ THEN_QUIT,
    THEN_RESTART,
    THEN_START_DEFAULT,
    THEN_SULOGIN,
    THEN_NEW_RUNLEVEL
} h_then;


/* The GLOBAL struct */
typedef struct
{
    char **Argv;
    int Argc;
    h_then when_out;
    h_sys_state sys_state;
    /*char *runlevel; */
    int interupt;

    m_h modules[MAX_MODULES];
    s_callers callers[MAX_CALLERS];

    service_h **config_database;
    int config_allocated;
    active_h **active_database;
    int active_allocated;

    history_h **history_db;
    int next_history;

    s_data_row *option_table;

    s_data s_data[M_S_D];
#ifdef RUNTIME_DEBUG
    int verbose;
#endif
} s_global;

extern s_global g;

void initng_new(void);
void initng_free(void);


/* standard wrappers using s_data */
#define s_get_string(type) d_get_string(type, g.s_data)
#define s_get_int(type) d_get_int(type, g.s_data)
#define s_get_next_string(type, last) d_get_next_string(type, g.s_data, last)
#define s_set_another_string(type, string) d_set_another_string(type, g.s_data, string)
#define s_set_string(type, string)  d_set_string(type, g.s_data, string)
#define s_set_int(type, value) d_set_int(type, g.s_data, value)
#define s_set(type) d_set(type, g.s_data)
#define s_is(type) d_is(type, g.s_data)
#define s_remove(type) d_remove(type, g.s_data)
#define s_remove_all() d_remove_all(g.s_data)

#endif
