
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdarg.h>

#include "initng.h"

#include "initng_global.h"

#include "initng_plugin_hook.h"
#include "initng_plugin.h"

int initng_del_hook(e_ptype t, void *hook)
{
    int i;

    for (i = 0; i < MAX_CALLERS; i++)
    {
        switch (t)
        {
            case FDWATCHERS:
                if (g.callers[i].ptype == t
                    && g.callers[i].c.fdh.call_module == hook)
                {
                    D_("DELETED FD %i ON CALLER #%i\n",
                       g.callers[i].c.fdh.fds, i);
                    g.callers[i].c.fdh.call_module = NULL;
                    g.callers[i].c.fdh.fds = 0;
                }
            default:
                if (g.callers[i].ptype == t && g.callers[i].c.hook == hook)
                {
                    g.callers[i].ptype = NOPLUG;
                    g.callers[i].c.hook = NULL;
                    return (TRUE);
                }
        }

    }
    return (FALSE);
}

int initng_add_hook(e_ptype t, void *hook, ...)
{
    /* TODO, this has to be cleaned up, we should scan va_start dynamically 
       and make one standard "int plugin_ext" or something for extended plugin data
       Has the added bonus that plugins can eventually use that as (char*) and add their own buffer of data?
     */
    int i;
    va_list list;
    int fd;

    /*D_("Adding hook type %i\n",t); */

    for (i = 0; i < MAX_CALLERS; i++)
        if (g.callers[i].ptype == NOPLUG)
            break;
    /*D_("found free space to add hook on #%i\n",i); */
    if (i == MAX_CALLERS)
        return (FALSE);

    if (t == FDWATCHERS)
    {
        /* Add us to FD watchers */
        va_start(list, hook);
        fd = va_arg(list, int);

        va_end(list);
        if (fd < 3)
        {
            F_("Filedescriptor must be >= 3.\n");
            return (FALSE);
        }
        g.callers[i].ptype = t;
        g.callers[i].c.fdh.call_module = hook;
        g.callers[i].c.fdh.fds = fd;
        D_("ADDED FD %i ON CALLER #%i\n", fd, i);
        return (TRUE);

    }

    g.callers[i].ptype = t;
    g.callers[i].c.hook = hook;
    D_("ADDED ON CALLER #%i\n", i);
    return (TRUE);
}
